unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls;

type
  TForm1 = class(TForm)
    BtnRight: TButton;
    BtnWrong: TButton;
    procedure BtnRightClick(Sender: TObject);
    procedure BtnWrongClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

type
  IMyInterface1 = interface
    ['{B80F24F8-9FE5-4DF0-A5BF-A434271A2A50}']
    function Test: HResult; stdcall;
  end;

  IMyInterface2 = interface
    ['{C9D669C7-1E16-45B4-A63D-09E9FF46C035}']
    function Test: HResult; stdcall;
  end;

  TMyObj1 = class(TInterfacedObject, IMyInterface1)
  protected
    // IMyInterface1
    function Test: HResult; stdcall;
  public
    // TMyObj
  end;

  TMyObj2 = class(TMyObj1, IMyInterface2)
  protected
    // IMyInterface2
    function Test: HResult; stdcall;
  public
    // TMyObj
  end;

  TMyObj3 = class(TMyObj2)
  public
    // TMyObj3
    function Test: HResult;
    constructor Create;
    destructor Destroy; override;
  end;

{ TMyObj1 }

function TMyObj1.Test: HResult;
begin
  ShowMessage('IMyInterface1.Test');
  Result := S_OK;
end;

{ TMyObj2 }

function TMyObj2.Test: HResult;
begin
  ShowMessage('IMyInterface2.Test');
  Result := S_OK;
end;

{ TMyObj3 }

constructor TMyObj3.Create;
begin
  ShowMessage('Constructor');
end;

destructor TMyObj3.Destroy;
begin
  ShowMessage('Destructor');
  inherited;
end;

function TMyObj3.Test: HResult;
begin
  ShowMessage('TMyObj3.Test');
  Result := S_OK;
end;

procedure TForm1.BtnRightClick(Sender: TObject);
var
  vMyInteface1: IMyInterface1;
  vMyInteface2: IMyInterface2;
  vMyObj3     : TMyObj3;
begin
  // Working with TMyObj3 as IMyInterface1
  vMyInteface1 := TMyObj3.Create as IMyInterface1;
  vMyInteface1.Test;
  vMyInteface1 := nil; // this step is optional, see comments in the end

  // Working with TMyObj3 as IMyInterface2
  vMyInteface2 := TMyObj3.Create as IMyInterface2;
  vMyInteface2.Test;
  vMyInteface2 := nil; // this step is optional, see comments in the end

  // Working with TMyObj3 as TMyObj3
  vMyObj3 := TMyObj3.Create;
  vMyObj3.Test;
  vMyObj3.Free;

  // vMyInteface1 & vMyInteface2 will free as soon
  // as they go out of scope because interfaces are
  // reference counted
end;

procedure TForm1.BtnWrongClick(Sender: TObject);
var
  vMyInteface1: TMyObj3;
  vMyInteface2: TMyObj3;
  vMyObj3     : TMyObj3;
begin
  // Working with TMyObj3 as IMyInterface1
  vMyInteface1 := TMyObj3.Create;
  (vMyInteface1 as IMyInterface1).Test;
  //vMyInteface1.Free; // <- uncomment to see AV

  // Working with TMyObj3 as IMyInterface2
  vMyInteface2 := TMyObj3.Create;
  (vMyInteface2 as IMyInterface2).Test;

  // Working with TMyObj3 as TMyObj3
  vMyObj3 := TMyObj3.Create;
  vMyObj3.Test;
  vMyObj3.Free;

  // vMyInteface1 & vMyInteface2 will free as soon
  // as they go out of scope because interfaces are
  // reference counted but we are holding references to
  // Objects not interfaces.  Do we?
end;

end.
